Package org.codehaus.groovy.util

# Enum ReferenceType

java.lang.Object
java.lang.Enum<ReferenceType>
org.codehaus.groovy.util.ReferenceType

All Implemented Interfaces:
  `Serializable`, `Comparable<ReferenceType>`, `java.lang.constant.Constable`

    public enum ReferenceType
    extends Enum<ReferenceType>

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant | Description
  --- | ---
  `HARD` |
  `PHANTOM` |
  `SOFT` |
  `WEAK` |

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `protected abstract <T,​ V extends Finalizable> Reference<T,​V>` | `createReference​(T value, V handler, ReferenceQueue queue)` |
  `static ReferenceType` | `valueOf​(String name)` | Returns the enum constant of this type with the specified name.
  `static ReferenceType[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### SOFT

    public static final ReferenceType SOFT

  - ### WEAK

    public static final ReferenceType WEAK

  - ### PHANTOM

    public static final ReferenceType PHANTOM

  - ### HARD

    public static final ReferenceType HARD

- ## Method Details

  - ### values

    public static ReferenceType[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static ReferenceType valueOf​(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### createReference

    protected abstract <T,​ V extends Finalizable> Reference<T,​V> createReference​(T value, V handler, ReferenceQueue queue)